/* Code by Taylor L. Hughes 6/2/2008
to compile simply use 

gcc -lm conductivity.c -o myprog
*/


#include <stdio.h> 
#include <math.h> 
#define PI 3.1415926536


int main() {

   
FILE *f; 
double MM=0.0;
double grid=600.0; 
 double div =1.0/grid;  
 
 //clear out file
 f = fopen ("uplot.dat", "w");// This is 
 fclose(f);

     /////////////////////////////DO Integral///////////
int inx=0; int iny=0; double sum=0.0; 


for(MM=-0.93;MM<5.0;MM+=0.05) {
 for(inx=0;inx< (int)grid;inx++) {
    for(iny=0;iny< (int)grid; iny++)
    {

sum+=2.0*(2.0*PI*div)*(2.0*PI*div)*((2-MM)*cos(2.0*PI*((float)inx)*div)*cos(2.0*PI*((float)iny)*div)-cos(2.0*PI*((float)iny)*div)-cos(2.0*PI*((float)inx)*div))/pow(2.0+(2.0-MM)*(2.0-MM)+2.0*cos(2.0*PI*((float)iny)*div)*cos(2.0*PI*((float)inx)*div)-2.0*(2.0-MM)*(cos(2.0*PI*((float)iny)*div)+cos(2.0*PI*((float)inx)*div)),1.5); 

     }
} 

//Properly normalize conductivity
 sum*=-3.0;
 sum/=((8.0*PI*PI));


//save to the file
   f = fopen ("uplot.dat", "a+");
   fprintf(f,"\n%g\t %g",MM,sum);
 }



return 0; }
